#ifndef _TIPOS_ARL_H_
#define _TIPOS_ARL_H_

#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define CELDA_VACIA 0
#define CELDA_OCUPADA 1
/* ahora se generan las macros que sirven para declarar listas */
/* de enteros y reales */
#define listaent(x,taml)  int x ## _elementos[taml];LISTA_GENERICA_ENTEROS x
#define listareal(x,taml) float x ## _elementos[taml];LISTA_GENERICA_REALES x

typedef struct {
	char *nombre;
	int cabeza;
	int cola;
	int tam;
	int num_elem;
	int *lista;
} LISTA_GENERICA_ENTEROS;

typedef struct {
	char *nombre;
	int cabeza;
	int cola;
	int tam;
	int num_elem;
	float *lista;
} LISTA_GENERICA_REALES;

//enumerado de los tipos admitidos para la impresin de arrays
typedef enum enum_tipos {boolean, entero, real} enum_tipos;

void inicializa_lent(LISTA_GENERICA_ENTEROS *lent, const int tamlis, char *nombre, int *elementos);
void inicializa_lreal(LISTA_GENERICA_REALES *lreal, const int tamlis, char *nombre, float *elementos);
void add_head_lent(const int num, LISTA_GENERICA_ENTEROS *lent);
void add_head_lreal(const float num, LISTA_GENERICA_REALES *lreal);
void add_tail_lent(const int num, LISTA_GENERICA_ENTEROS *lent);
void add_tail_lreal(const float num, LISTA_GENERICA_REALES *lreal);
int head_lent(const LISTA_GENERICA_ENTEROS *lent);
int tail_lent(const LISTA_GENERICA_ENTEROS *lent);
float head_lreal(const LISTA_GENERICA_REALES *lreal);
float tail_lreal(const LISTA_GENERICA_REALES *lreal);
int pop_head_lent(LISTA_GENERICA_ENTEROS *lent);
int pop_tail_lent(LISTA_GENERICA_ENTEROS *lent);
float pop_head_lreal(LISTA_GENERICA_REALES *lreal);
float pop_tail_lreal(LISTA_GENERICA_REALES *lreal);
void print_lent(FILE *fd, const LISTA_GENERICA_ENTEROS *lent);
void print_lreal(FILE *fd, const LISTA_GENERICA_REALES *lreal);
void print_array(FILE *fd, void *array, const enum_tipos tipo, const int tam);

#endif //_TIPOS_ARL_H_

